var ws = null;
var pc;
var audio_video_stream;
var recorder = null;
var aa_streams = [];
var mediaConstraints = {
     optional: [],
     mandatory: {
         OfferToReceiveAudio: true,
         OfferToReceiveVideo: true
     }
};
var iceCandidates = [];
var flg_view = 0;
var flg_record = 0;
var remoteVideo = document.getElementById("remote-video");
var localVideo = document.getElementById('play-video');
var rec_flg = 1;
var pcConfig = {/*sdpSemantics : "plan-b"*,*/ "iceServers": [
    {"urls": ["stun:stun1.l.google.com:19302", "stun:stun2.l.google.com:19302"]}
]};

const auth = firebase.auth();
const db = firebase.firestore();

set_Btn(["pause", "mute1", "mute2", 'stop', 'photo', "record", "play", 'dn_photo', 'dn_video', '_up', '_left', '_right', '_down', '_home'], 0);

db.collection("uv4l").doc("raspi").set({what: "none", data: "none"});

disp_locate();

document.getElementById("_state").innerHTML = "Ready";

const _message = db.collection('uv4l').doc('raspi');
_message.onSnapshot( 
    (sshot) => {
    var msg = sshot.data();
    var what = msg.what;
    var data = msg.data;
    console.log("message =" + what);
    switch(what)
    {
        case "offer":
                document.getElementById("_state").innerHTML = "Get Offer";
                pc.setRemoteDescription(new RTCSessionDescription(JSON.parse(data)),
                    function onRemoteSdpSuccess() {
                        remoteDesc = true;
                        addIceCandidates();
                        console.log('onRemoteSdpSucces()');
                        pc.createAnswer(function (sessionDescription) {
                            pc.setLocalDescription(sessionDescription);
                            var request = {
                                what: "answer",
                                data: JSON.stringify(sessionDescription)
                            };
                            db.collection("uv4l").doc("client").set(request);
                            console.log(request);
                        }, function (error) {
                            alert("Failed to createAnswer: " + error);
                        }, mediaConstraints);
                    },
                    function onRemoteSdpError(event) {
                        alert('Failed to set remote description (unsupported codec on this browser?): ' + event);
                        stop();
                    }
                );
                break;

        case "iceCandidate": // when trickle is enabled
                document.getElementById("_state").innerHTML = "Get IceCandidate";
                if (!data) { 
                    console.log("Ice Gathering Complete");
                    document.getElementById("_state").innerHTML = "Ice Gathering Complete";
                    break;
                }
                var elt = JSON.parse(data);
                let candidate = new RTCIceCandidate({sdpMLineIndex: elt.sdpMLineIndex, candidate: elt.candidate});
                iceCandidates.push(candidate);
                if (remoteDesc)
                    addIceCandidates();
                document.documentElement.style.cursor = 'default';
                break;

        case "iceCandidates":
                document.getElementById("_state").innerHTML = "Get IceCandidates";
                var candidates = JSON.parse(msg.data);
                for (var i = 0; candidates && i < candidates.length; i++) {
                    var elt = candidates[i];
                    let candidate = new RTCIceCandidate({sdpMLineIndex: elt.sdpMLineIndex, candidate: elt.candidate});
                    iceCandidates.push(candidate);
                }
                if (remoteDesc) addIceCandidates();
                document.documentElement.style.cursor = 'default';
                break;
    
        case "locate":
                set_cursor(data);
                document.getElementById("_locate").innerHTML = "U:" + String(0 - msg.u) + ",R:" + String(0 - msg.r);
                break;

        case "light":
                if(data) {
                    document.getElementById('_light').innerHTML = 'ON';
                    document.getElementById('_light').style.backgroundColor = "red";
                }
                else {
                    document.getElementById('_light').innerHTML = 'OFF';
                    document.getElementById('_light').style.backgroundColor = "#228b22";
                }
                break;
    
    }
});  

async function disp_locate(){
    var temp = await db.collection("uv4l").doc("state").get();
    temp = temp.data();
    document.getElementById("_locate").innerHTML = "U:" + String(0 - temp.u) + ",R:" + String(temp.r);
}

function set_light(data) {
    console.log("data = " + data);
    if(data) {
        document.getElementById('_light').innerHTML = 'ON';
        document.getElementById('_light').style.backgroundColor = "red";
    }
    else {
        document.getElementById('light').innerHTML = 'OFF';
        document.getElementById('light').style.backgroundColor = "#228b22";
    }
}

function set_cursor(data) {
    console.log("cursor = " + data.toString(16));
    set_Btn(["_up"], data & 1);
    set_Btn(["_down"], data & 2);
    set_Btn(["_right"], data & 4);
    set_Btn(["_left"], data & 8);
    set_Btn(["_home"], data & 16);
}

async function busy_check(check_data) {
    var flg = 1;
    while(flg) {
        var flg_st = await db.collection("uv4l").doc("state").get();
        var flg_state = flg_st.data();
        if(flg_state.signal == check_data) flg = 0;
        console.log('state:', flg_state.signal);
    }
}

async function start() {
    set_Btn(['start'], 0);
    document.getElementById("stop").disabled = false;
    document.getElementById("start").disabled = true;
    document.documentElement.style.cursor = 'wait';

    db.collection("uv4l").doc("client").set({what: "open"});
    document.getElementById("_state").innerHTML = "Opening Signal Server!";
    await busy_check("connect");
    document.getElementById("_state").innerHTML = "Opened.";

  // Initialize Cloud Firestore and get a reference to the service

    iceCandidates = [];
    remoteDesc = false;
    audio_video_stream = await navigator.mediaDevices.getUserMedia({video: false, 
        audio: {
            echoCancellation: true,
            noiseSuppression: false
        }
    });
    createPeerConnection();
    audio_video_stream.getTracks().forEach(track => pc.addTrack(track, audio_video_stream));
    var request = {
            what: "call",
            options: {
                force_hw_vcodec: false,
                vformat: "30",
                trickle_ice: true
//                trickle_ice: false
            }
    };
    
    db.collection("uv4l").doc("client").set(request);
    document.getElementById("_state").innerHTML = "Send Call";
}

async function stop() {
    set_Btn(["pause", "mute1", "mute2", 'stop', 'photo', "record", "play", 'dn_photo', 'dn_video', '_up', '_left', '_right', '_down', '_home'], 0);
    set_Btn(['start'], 1);

    if (audio_video_stream) {
        try {
            if (audio_video_stream.getVideoTracks().length)
                audio_video_stream.getVideoTracks()[0].stop();
            if (audio_video_stream.getAudioTracks().length)
                audio_video_stream.getAudioTracks()[0].stop();
            audio_video_stream.stop(); // deprecated
        } catch (e) {
            for (var i = 0; i < audio_video_stream.getTracks().length; i++)
                audio_video_stream.getTracks()[i].stop();1
        }
        audio_video_stream = null;
    }
    document.getElementById('remote-video').srcObject = null;
    document.getElementById('remote-video').src = ''; // TODO; remove
    if (pc) {
        pc.close();
        pc = null;
        db.collection("uv4l").doc("client").set({what: "close"});
        await busy_check("none");
        document.getElementById("_state").innerHTML = "Close Signal Server!";
    }
    document.getElementById("stop").disabled = true;
    document.getElementById("start").disabled = false;
    document.documentElement.style.cursor = 'default';
}

function signOut() {
    firebase.auth().onAuthStateChanged(user => {
      firebase
        .auth()
        .signOut()
        .then(() => {
          console.log('ログアウトしました');
          location.reload();
        })
        .catch((error) => {
          console.log(`ログアウト時にエラーが発生しました (${error})`);
        });
    });
  }

window.addEventListener('beforeunload', function (e) {
    stop();
    signOut();
});

async function light(){
    var _temp = await db.collection("uv4l").doc("state").get();
    _temp = _temp.data();
    var data = ! _temp.light;
    await db.collection("uv4l").doc("state").update({light: data});
    await db.collection("uv4l").doc("client").set({what: "light", data: data});
}

async function reboot(){
    if(window.confirm('本当にいいんですね？')){
        await db.collection("uv4l").doc("client").set({what: "reboot", data: 0});
	}
}

async function control_cam(_no){
    var r_max = 80;
    var u_max = 60;
    set_Btn(['_up', '_left', '_right', '_down', '_home'], 0);
    var _locate = await db.collection("uv4l").doc("state").get();
    _locate = _locate.data();
    var _r = _locate.r;
    var _u = _locate.u; 
    var motor_flg = 0x1f;

    switch(_no) {
        case "u":   _u -= 10;
                    break;
        case "d":   _u += 10;
                    _no = "u";
                    break;
        case "r":   _r -= 10;
                    break;
        case "l":   _r += 10;
                    _no = "r";
                    break;
        case "h":   _r = _u = 0;
                    motor_flg = 0x0f;
                    break;
    }
    if(_u == u_max) motor_flg &= 0x1d;
    if(_u == -u_max) motor_flg &= 0x1e;
    if(_r == r_max) motor_flg &= 0x17;
    if(_r == -r_max) motor_flg &= 0x1b;

    await db.collection("uv4l").doc("state").update({r: _r, u: _u, motor: motor_flg});        
    await db.collection("uv4l").doc("client").set({what: "locate", no: _no, u: _u , r: _r, motor: motor_flg});

}

function createPeerConnection() {
     try {
         pc = new RTCPeerConnection(pcConfig);
         pc.onicecandidate = onIceCandidate;
         pc.ontrack = onTrack;
         pc.onremovestream = onRemoteStreamRemoved;
         console.log("peer connection successfully created!");
         document.getElementById("_state").innerHTML = "Peer Connection Successfully created!";
        } catch (e) {
         console.error("createPeerConnection() failed");
     }
 }

 async function onIceCandidate(event) {
     if (event.candidate && event.candidate.candidate) {
         var candidate = {
             sdpMLineIndex: event.candidate.sdpMLineIndex,
             sdpMid: event.candidate.sdpMid,
             candidate: event.candidate.candidate
         };
         var request = {
             what: "addIceCandidate",
             data: JSON.stringify(candidate)
         };
         await db.collection("uv4l").doc("client").set(request);
     } else {
         console.log("End of candidates.");
         document.getElementById("_state").innerHTML = "End of candidates.";
     }
 }

 function addIceCandidates() {
    iceCandidates.forEach(function (candidate) {
         pc.addIceCandidate(candidate,
             function () {
                 console.log("IceCandidate added: " + JSON.stringify(candidate));
             },
             function (error) {
                 console.error("addIceCandidate error: " + error);
             }
         );
     });
     iceCandidates = [];
 }

 async function onTrack(event) {
     console.log("Remote track!");
     var remoteVideoElement = document.getElementById('remote-video');
     remoteVideoElement.srcObject = event.streams[0];
     aa_streams[0] = event.streams[0];
     set_Btn(["pause", "mute1", "mute2", 'stop', 'photo', "record"], 1);
     var flg = await db.collection("uv4l").doc("state").get();
     flg = flg.data();
     if (flg.m1) remoteVideo.muted = 1;
     if (flg.m2) {
        var audioTrack = audio_video_stream.getAudioTracks()[0];
        audioTrack.enabled = 0;  
     }
     set_cursor(flg.motor);
     document.getElementById("_locate").innerHTML = "U:" + String(0 - flg.u) + ",R:" + String(flg.r);
    }

 function onRemoteStreamRemoved(event) {
     var remoteVideoElement = document.getElementById('remote-video');
     remoteVideoElement.srcObject = null;
     remoteVideoElement.src = ''; // TODO: remove
 }

 function pause() {
     set_Btn(["play", 'dn_photo', 'dn_video'], 0);
     set_Btn(["mute1", "mute2", 'stop', 'photo', "record"], remoteVideo.paused);
     if (remoteVideo.paused){
         if(flg_view == 1){
             remoteVideo.style.display = "";
             document.getElementById('play-video').style.display = "none";
             flg_view = 0;
        }
         document.getElementById("pause").innerHTML = 'Pause';
         remoteVideo.play();
     }
     else{
         remoteVideo.pause();
         document.getElementById('pause').innerHTML = 'Back';
     }

     set_Btn(["pause"],1);
 }

 async function mute(data) {
    var flg = await db.collection("uv4l").doc("state").get();
    flg = flg.data();
    var col = '#228b22';
    if(data == 1){
        data = ! flg.m1;
        if(data) col = 'red';
        document.getElementById('mute1').style.backgroundColor = col;
        remoteVideo.muted = data;
        db.collection("uv4l").doc("state").update({m1: data});
      }
     else {
        var audioTrack = audio_video_stream.getAudioTracks()[0];
        data = ! flg.m2;
        if(data) col = 'red';
        audioTrack.enabled = ! data;  
        document.getElementById('mute2').style.backgroundColor = col;
        db.collection("uv4l").doc("state").update({m2: data});
     }
 }

 function download() {
     if (recordedBlobs !== undefined) {
         var blob = new Blob(recordedBlobs, {type: 'video/webm'});
         var url = URL.createObjectURL(blob);
         var a = document.createElement('a');
         a.style.display = 'none';
         a.href = url;
         a.download = 'video.webm';
         document.body.appendChild(a);
         a.click();
         setTimeout(function () {
             document.body.removeChild(a);
             URL.revokeObjectURL(url);
         }, 100);
     }
 }

 function start_stop_record() {
     set_Btn(["start", "pause", "mute1", "mute2", 'stop', 'photo', "play", 'dn_video', 'dn_photo'], 0);
     set_Btn([record],1);
     document.getElementById('pause').innerHTML = 'Back';
     if (pc && !flg_record) {
         if (aa_streams.length) {
             console.log("Starting recording");
             startRecording(aa_streams[0]);
             document.getElementById('record').innerHTML = 'Stop';
             flg_record = 1;
         }
     }
     else {
             console.log("Stop recording");
             set_Btn(["pause", "record", "play", 'dn_video'], 1);
             stop_record();
             document.getElementById('record').innerHTML = 'Video';
             remoteVideo.pause();
             set_Btn(["record"],0);
             flg_record = 0;
     }
 }

 function startRecording(stream) {
     recordedBlobs = [];
     var options = {mimeType: 'video/webm;codecs=vp9,opus'};
     if (!MediaRecorder.isTypeSupported(options.mimeType)) {
         console.log(options.mimeType + ' is not Supported');
         //options = {mimeType: 'video/webm;codecs=vp8'};
         options = {mimeType: 'video/webm;codecs=vp8,opus'};
         if (!MediaRecorder.isTypeSupported(options.mimeType)) {
             console.log(options.mimeType + ' is not Supported');
             options = {mimeType: 'video/webm;codecs=h264'};
             if (!MediaRecorder.isTypeSupported(options.mimeType)) {
                 console.log(options.mimeType + ' is not Supported');
                 options = {mimeType: 'video/webm'};
                 if (!MediaRecorder.isTypeSupported(options.mimeType)) {
                     console.log(options.mimeType + ' is not Supported');
                     options = {mimeType: ''};
                 }
             }
         }
     }
     try {
         recorder = new MediaRecorder(stream, options);
     } catch (e) {
         console.error('Exception while creating MediaRecorder: ' + e);
         alert('Exception while creating MediaRecorder: ' + e + '. mimeType: ' + options.mimeType);
         return;
     }
     console.log('Created MediaRecorder', recorder, 'with options', options);
     recorder.ondataavailable = handleDataAvailable;
     recorder.onwarning = function (e) {
         console.log('Warning: ' + e);
     };
     recorder.start();
     console.log('MediaRecorder started', recorder);
 }

 function stop_record() {
     if (recorder) {
         recorder.stop();
         console.log("recording stopped");
         document.getElementById('record').innerHTML = 'Video';
         recorder = null;
     }
 }

 function handleDataAvailable(event) {
     //console.log(event);
     if (event.data && event.data.size > 0) {
         recordedBlobs.push(event.data);
     }
 }

 function play_video() {
     set_Btn(["start", "mute1", "mute2", 'stop', 'photo', "record", 'dn_photo'], 0);
     set_Btn(["pause", "play", 'dn_video'], 1);
     document.getElementById('pause').innerHTML = 'Back';
     console.log('Play video');
     recorder = null;
     flg_view = 1;
     remoteVideo.style.display = "none";
     remoteVideo.pause();
     
     var mute = remoteVideo.muted;
     remoteVideo.muted = "true";
     document.getElementById('play-video').style.display = "";

     var superBuffer = new Blob(recordedBlobs, {type: 'video/webm'});
     var recordedVideoElement = document.getElementById('play-video');
     recordedVideoElement.src = URL.createObjectURL(superBuffer);

     remoteVideo.muted = mute;
 }

 function dn_photo(){
     var canvas = document.querySelector('canvas');
     var url = canvas.toDataURL('image/jpeg', 1.0);
     var a = document.createElement('a');
     a.style.display = 'none';
     a.href = url;
     a.download = 'pic.jpg';
     document.body.appendChild(a);
     a.click();
     setTimeout(function () {
     document.body.removeChild(a);
         window.URL.revokeObjectURL(url);
     }, 100);
 }

 function take_photo() {
     set_Btn(['start', "mute1", "mute2", 'stop', "record", "play", 'dn_video'], 0);
     set_Btn(['pause', "photo", 'dn_photo'], 1);
     document.getElementById('pause').innerHTML = 'Back';
     remoteVideo.pause();
     var canvas = document.querySelector('canvas');
     canvas.width = remoteVideo.videoWidth;
     canvas.height = remoteVideo.videoHeight;
     canvas.getContext('2d').drawImage(remoteVideo, 0, 0, canvas.width, canvas.height);
 }

 async function set_Btn(b_buf, flg) {
     var temp = await db.collection("uv4l").doc("state").get();
     temp = temp.data();
     for (i = 0; i < b_buf.length; i ++) {
         var flg_able = true;
         var flg_back = "gray";
         if(flg){
             flg_able = false;
             flg_back = "#228b22";
        }
         document.getElementById(b_buf[i]).disabled = flg_able;
         if(b_buf[i] == "mute1" && flg_back != "gray") {
            if (temp.m1) flg_back = 'red';
         }
         if(b_buf[i] == "mute2" && flg_back != "gray") {
            if (temp.m2) flg_back = 'red';
         }
        document.getElementById(b_buf[i]).style.backgroundColor = flg_back;
     }
 }

 